# -*- coding: UTF-8 -*-
import math
import struct
import sys

def mmk(xlist, ylist):
	"""
	Приближение функции методом наименьших квадратов
	Считаем, что функция есть линейный график.
	y = a + b*x
	определяем a и b. 
	"""
	assert(len(xlist)==len(ylist))
	xsum = 0.0
	ysum = 0.0
	xysum = 0.0
	x2sum = 0.0
	n = len(xlist)
	for i in xrange(0, n):
		x = xlist[i]
		y = ylist[i]
		xsum+=x
		ysum+=y
		xysum+=x*y
		x2sum+=x*x

	Z = n*x2sum - xsum*xsum

	b = (n*xysum-xsum*ysum)/Z
	a = (ysum*x2sum-xysum*xsum)/Z
	return (a,b)

def fexp(t, a, b, Vcc):
	return a+Vcc*(1-math.exp(-t/b))

def norm(xlist, ylist, a,b, Vcc):
	sum = 0
	for i in xrange(0, len(xlist)):
		dy = ylist[i] - fexp(xlist[i], a, b, Vcc)
		sum += dy*dy
	return sum

def fineTuning(xlist, ylist, astart, bstart, Vcc):
	"""
	Эта сложная математика не нужна
	Достаточно линейной аппроксимации
	"""
	afine = astart
	bfine = bstart
	minsum = norm(xlist, ylist, afine, bfine, Vcc)

	count = 100
	ifine = 0

	for z in xrange(-count//2, +count//2):
		b = bstart*(1+z*0.1/count)
		a = 0
		for i in xrange(0, len(xlist)):
			a += ylist[i] - fexp(xlist[i], 0, b, Vcc)
		a/=len(xlist)
		sum = norm(xlist, ylist, a, b, Vcc)
		#print "b="+str(b), "a="+str(a), "sum="+str(sum)

		if sum<minsum:
			minsum = sum
			afine = a
			bfine = b
			ifine = z
	print "ifine="+str(ifine)

	return afine, bfine
